package org.foo.foo;

import org.foo.barapi.IBar;



public class FooImpl implements IFoo{

	private IBar m_bar=null;
	
	protected void setBar(IBar b) {
		System.out.println("Depend Injection - Setting Bar");
		m_bar=b;
	}
	
	protected void unsetBar(IBar B){
		System.out.println("Depend Injection - Unsetting Bar");
		m_bar=null;
	}
	
	protected void start() {
		System.out.println("Starting comp Foo and calling doFoo");
		doFoo();
	}
	
	protected void stop() {
		System.out.println("Stopping comp Foo");
	}
	
	public void doFoo() {
		if (m_bar!=null) {
			System.out.println("FooImpl will use Bar by calling doBar");
			m_bar.doBar();
		}
		
		
	}
}
